unit ShellPlusDMUnit;

interface

uses
    Windows,
    Messages,
    SysUtils,
    Classes,
    Registry,
    Forms,
    {$IFNDEF VER100}
    ImgList,
    {$ENDIF}
    SxDataModule, SxCustShlObj, SxExtractIcon, Controls, Graphics, SxComObj;

type
  TSxModule1 = class(TSxModule)
    SxExtractIcon1: TSxExtractIcon;
    LargeImages: TImageList;
    SmallImages: TImageList;
    ExtraLargeImages: TImageList;
    procedure SxExtractIcon1ExtractIconEx(Sender: TObject; var IconExtraLarge,
      IconLarge, IconSmall: TIcon);
    procedure SxExtractIcon1KeyAlreadyExist(RegisteredClass: TGUID;
      var Overwrite: Boolean);
    procedure SxExtractIcon1UpdateRegistry(Sender: TObject;
      Register: Boolean);
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  end;

{GLOBAL VARAIBLES}
var
  Reg:TRegistry;
  FileType:string;

implementation

uses ComServ, Dialogs, StoreLastGUIDUnit, SxTools;

{$R *.DFM}

procedure TSxModule1.SxExtractIcon1ExtractIconEx(Sender: TObject;
  var IconExtraLarge, IconLarge, IconSmall: TIcon);
begin
  if SxGetFileSize((Sender as TSxExtractIcon).FileName)<>0 then
  begin
    ExtraLargeImages.GetIcon(1, IconExtraLarge);
    LargeImages.GetIcon(1,IconLarge);
    SmallImages.GetIcon(1,IconSmall);
  end
  else
  begin
    ExtraLargeImages.GetIcon(0, IconExtraLarge);
    LargeImages.GetIcon(0,IconLarge);
    SmallImages.GetIcon(0,IconSmall);
  end;
end;

procedure TSxModule1.SxExtractIcon1KeyAlreadyExist(RegisteredClass: TGUID;
  var Overwrite: Boolean);
var
  GUIDWindow: TGUIDWindow;
begin
  Overwrite:=MessageDlg('Extension already registered. Owerwrite?', mtWarning, [mbYes, mbNo], 0)=mrYes;
  if Overwrite then
  begin
    GUIDWindow:=TGUIDWindow.CreateParented(0);
    FileType:=SxExtractIcon1.FileType;
    Reg := TRegistry.Create;
    try //saving previous GUID to registry
      Reg.RootKey := HKEY_CLASSES_ROOT;
      if Reg.OpenKey('\'+FileType+'\shellex\IconHandler\', false) then
        begin
         Reg.WriteString('PrevGUID',GUIDToString(RegisteredClass));
         Reg.CloseKey;
        end;
      GUIDWindow.Caption:='Store this GUID';
      GUIDWindow.Label2.Caption:='Current shell extension will overwrite the ExtractImage handler specified above. Please store this GUID value to roll back changes later.';
      GUIDWindow.Button2.Enabled:=false;
      GUIDWindow.ShowModal;
    finally
      FreeAndNil(GUIDWindow);
      FreeAndNil(Reg);
    end;
  end;
end;

procedure TSxModule1.SxExtractIcon1UpdateRegistry(Sender: TObject;
  Register: Boolean);
var
  prevGUIDStored:boolean;
  PrevGUIDval,Temp_Val:string;
  GUIDWindow: TGUIDWindow;
begin

  if not Register then
  begin
    GUIDWindow:=TGUIDWindow.CreateParented(0);
    FileType:=SxExtractIcon1.FileType;     //check for stored previous GUID
    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_CLASSES_ROOT;
      if Reg.OpenKey('\'+FileType+'\shellex\IconHandler\', false) then
      begin
        prevGUIDval:=Reg.ReadString('PrevGUID');
        prevGUIDStored:=prevGUIDval<>'';
        Reg.CloseKey;
      end;
    finally
      Reg.Free;
    end;     //end check

    try
      GUIDWindow.Caption:='Restore previous Icon Handler';
      if prevGUIDStored then
      begin
        GUIDWindow.Label1.Caption:='Please specify ExtractIcon handler CLSID to restore.';
        GUIDWindow.Label2.Caption:='Do not specify any CLSID value to automatically restore previous handler if it was stored.';
        GUIDWindow.Button2.Enabled:=True;
        GUIDWindow.ShowModal;

        if GUIDWindow.ModalResult=mrOk then
        begin
          if GUIDWindow.GUID.Text<>'' then //store typed GUID
          (Sender as TSxExtractIcon).RestoreLastGuid(GUIDWindow.GUID.Text)
          else //restore default system Icon Handler for file extension - editor is empty
          begin
             Reg := TRegistry.Create;
             try
               Reg.RootKey := HKEY_CLASSES_ROOT;
               if Reg.OpenKey('\'+FileType+'\shellex\IconHandler\', false) then
                  Reg.DeleteKey('\'+FileType+'\shellex\')
               else
                  ShowMessage('could not open HKEY_CLASSES_ROOT\'+FileType+'\shellex\IconHandler\ ');
              finally
                FreeAndNil(reg);
              end;
          end;
        end;

        if GUIDWindow.ModalResult=mrCancel then //Exchange Current and Previous registered GUID values in registry
        begin
          Reg := TRegistry.Create;
          try
            Reg.RootKey := HKEY_CLASSES_ROOT;
            if Reg.OpenKey('\'+FileType+'\shellex\IconHandler\', false) then
            begin
              Temp_val:=Reg.ReadString('');
              (Sender as TSxExtractIcon).RestoreLastGuid(prevGUIDval);
              Reg.WriteString('PrevGUID',Temp_val);
              Reg.CloseKey;
            end;
          finally
            FreeAndNil(Reg);
          end;
        end;
      end;
    finally
      FreeAndNil(GUIDWindow);
    end;
  end;
end;


initialization
    RegisterSxDataModule(ComServer,TSxModule1);
end.








